#include <windows.h>

#define CM_EXIT  101
#define CM_RED   201
#define CM_GREEN 202
#define CM_BLUE  203

LRESULT CALLBACK ExamWndProc
     ( HWND hWnd, UINT Message, UINT wParam, LONG lParam );


int WINAPI WinMain(HINSTANCE hInstance,     //  
                   HINSTANCE hPrevInstance, //   
                   LPSTR lpszCmdParam,      //  
                   int nCmdShow)            //  

{ HWND hWnd;           //  
  WNDCLASS WndClass;   //   
  MSG Msg;             //  ""
  HACCEL hAccel;		  //  
  char szClassName[] = "Example2"; //   

  /*    */
  WndClass.style = CS_HREDRAW | CS_VREDRAW; //  
  WndClass.lpfnWndProc = ExamWndProc; //    !
  WndClass.cbClsExtra = 0; //  
  WndClass.cbWndExtra = 0; //  
  WndClass.hInstance = hInstance; //  
  WndClass.hIcon   = LoadIcon(hInstance,"ICON_1"); //   
  WndClass.hCursor = LoadCursor(NULL,IDC_ARROW);  //  
  WndClass.hbrBackground = (HBRUSH) GetStockObject(NULL_BRUSH); //  
  WndClass.lpszMenuName = "MENU_1"; //   
  WndClass.lpszClassName = szClassName; //   

  /*    */
  if (! RegisterClass(&WndClass) )
  {
    MessageBox(NULL,"Cannot register class","Error",MB_OK);
    return 1; //     ,  
  }

  /*   */
  hWnd = CreateWindow(szClassName, //   
  							 "Example N2", //   ( )
                      WS_OVERLAPPEDWINDOW, //  
                      CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
                      CW_USEDEFAULT, CW_USEDEFAULT, // , 
                      NULL, //   
                      NULL, //   ( )
                      hInstance, //  
                      NULL); //    

 if (!hWnd)
 {
   MessageBox(NULL,"Cannot create Window","Error",MB_OK);
   return 2; //  ,     
 }

 hAccel = LoadAccelerators(hInstance,"ACCELERATORS_1");

 ShowWindow(hWnd,nCmdShow); //   (  )
 UpdateWindow(hWnd); //    WM_PAINT   

 /*       WM_QUIT */
 while (GetMessage(&Msg, //   
                   NULL, //  ,  NULL,     
                   0,0)) //   ( 0,0,  )
 {
  if (!TranslateAccelerator(hWnd,hAccel,&Msg) )
  {
   TranslateMessage(&Msg); //     
   DispatchMessage(&Msg);  //  
  }
 }
 return Msg.wParam; //   ,   WM_QUIT
}


/*   */
LRESULT CALLBACK ExamWndProc
     ( HWND hWnd,     //  ,   
       UINT Message,  //  
       UINT wParam, //  ,     
       LONG lParam ) //  ,     
{
  HDC hDC;  //  ,    
  PAINTSTRUCT PaintStruc; //     
  RECT Rect; //  
  POINT Point; //  
  static HPEN hRedPen,hGreenPen,hBluePen; //   
  static HPEN hPen;
  static HMENU hMenu;
  HPEN OldPen; //   

  switch (Message)
  {
   case WM_CREATE  :
      hRedPen   = CreatePen(PS_SOLID,5,RGB(255,0,0)); //  
      hGreenPen = CreatePen(PS_SOLID,5,RGB(0,255,0));
      hBluePen  = CreatePen(PS_SOLID,5,RGB(0,0,255));
      hPen = hBluePen;
      hMenu = GetMenu(hWnd);
      CheckMenuItem(hMenu,CM_BLUE,MF_CHECKED);
      return 0;

   case WM_PAINT   :
 		//       BeginPaint
      hDC = BeginPaint(hWnd,&PaintStruc); //   
      GetClientRect(hWnd,&Rect); //   
      OldPen = SelectObject (hDC,hPen); //   ,  
      MoveToEx(hDC,0,0,&Point); LineTo(hDC,Rect.right,Rect.bottom); // 
      MoveToEx(hDC,0,Rect.bottom,&Point); LineTo(hDC,Rect.right,0); //  
      SelectObject(hWnd,OldPen); //   
 		EndPaint(hWnd,&PaintStruc); //  
      return 0; //  0,    

   case WM_DESTROY :
      DeleteObject(hBluePen); //    
      DeleteObject(hGreenPen);
      DeleteObject(hRedPen);
      PostQuitMessage(0); //     WM_QUIT
   	return 0;           //   ,    0

   case WM_COMMAND : // c  

        switch (LOWORD(wParam))
        {
         case CM_EXIT : PostMessage(hWnd,WM_CLOSE,0,0);
                        break;
         case CM_RED  : hPen = hRedPen;
      						CheckMenuItem(hMenu,CM_BLUE,MF_UNCHECKED);
      						CheckMenuItem(hMenu,CM_GREEN,MF_UNCHECKED);
      						CheckMenuItem(hMenu,CM_RED,MF_CHECKED);
         				   // InvalidateRect(hWnd,NULL,TRUE);
                        break;
         case CM_GREEN : hPen = hGreenPen;
      						CheckMenuItem(hMenu,CM_BLUE,MF_UNCHECKED);
      						CheckMenuItem(hMenu,CM_GREEN,MF_CHECKED);
      						CheckMenuItem(hMenu,CM_RED,MF_UNCHECKED);
         				   InvalidateRect(hWnd,NULL,TRUE);
                        break;
         case CM_BLUE : hPen = hBluePen;
      						CheckMenuItem(hMenu,CM_BLUE,MF_CHECKED);
      						CheckMenuItem(hMenu,CM_GREEN,MF_UNCHECKED);
      						CheckMenuItem(hMenu,CM_RED,MF_UNCHECKED);
         				   InvalidateRect(hWnd,NULL,TRUE);
                        break;
        }
        return 0;

   case WM_CLOSE : MessageBeep(MB_ICONQUESTION);
                   if (MessageBox(hWnd," ?"," Exit",
                       MB_ICONQUESTION | MB_YESNO) != IDYES) return 0;
   default :
     //      :
     return DefWindowProc(hWnd,Message,wParam,lParam);
  }
}



